<?php

namespace Lara\Utils\Common;
use Lara\Utils\Common as Common;
use Lara\Utils\Common\WPHelperFunctions as WPHelperFunctions;

/**
 * @package    Google Analytics by Lara
 * @author     Amr M. Ibrahim <mailamr@gmail.com>
 * @link       https://www.xtraorbit.com/
 * @copyright  Copyright (c) XtraOrbit Web development SRL 2016 - 2020
 */

if (!defined("ABSPATH"))
    die("This file cannot be accessed directly");

require_once("exception.class.php");

class permissions{
	private $laraStockPermissions;
	private $userPermissions;
	private $userRoles;
	private $output  = array();
	private $errors  = array();	
	
	function __construct(){
		$this->laraStockPermissions =  array(
											array( "id"      => "permissions",
												   "name"    => __('Permissions', 'lara-google-analytics'),
												   "icon"    => "fa-key",
												   "type"    => "checkbox",
												   "default" => "",
												   "permissions" => array(array("name" => "lrgawidget_perm_perm",     "label" => __('Super Administrator [Change Permissions]', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_admin",    "label" => __('Administrator [Change Settings]', 'lara-google-analytics'))
																		  )
													),		
											array( "id"      => "tabs",
												   "name"    => __('Tabs', 'lara-google-analytics'),
												   "icon"    => "fa-bar-chart",
												   "type"    => "checkbox",
												   "default" => "",
												   "permissions" => array(array("name" => "lrgawidget_perm_daterange",    "label" => __('Change Date Range', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_graph_options","label" => __('Edit Graph Options', 'lara-google-analytics')),	
																		  array("name" => "lrgawidget_perm_sessions",     "label" => __('Sessions', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_realtime",     "label" => __('Real Time', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_countries",    "label" => __('Countries', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_browsers",     "label" => __('Browsers', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_languages",    "label" => __('Languages', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_os",           "label" => __('Operating Systems', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_devices",      "label" => __('Devices', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_screenres",    "label" => __('Screen Resolutions', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_keywords",     "label" => __('Keywords', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_sources",      "label" => __('Sources', 'lara-google-analytics')),
																		  array("name" => "lrgawidget_perm_pages",        "label" => __('Pages', 'lara-google-analytics'))
													)
												),
											array( "id"      => "ecommerce",
												   "name"    => __('eCommerce Graphs', 'lara-google-analytics'),
												   "icon"    => "fa-usd",
												   "type"    => "radio",
												   "default" => "lrgawidget_perm_ecom_woo",
												   "permissions" => array(array("name" => "lrgawidget_perm_ecom_woo",  "label" => __('WooCommerce', 'lara-google-analytics')." [".__('beta', 'lara-google-analytics')."]"),
																		  array("name" => "lrgawidget_perm_ecom_edd",  "label" => __('Easy Digital Downloads', 'lara-google-analytics')." [".__('comming soon', 'lara-google-analytics')."]")
														)
													),													
											);

		$this->userRoles        = array("administrator");
		$this->userPermissions  = array("lrgawidget_perm_perm");
	}
	
	private function getRoles(){
		global $wp_roles;
		$currentRoles = array();
		$roles = $wp_roles->roles;
		foreach ($roles as $role => $properties){
			$currentRoles[] = array('id' => $role, 'name' => $properties['name']);
		}
		return $currentRoles;
	}
	
	public function getCurrentBlogRolesPermissions(){
		if (in_array("lrgawidget_perm_perm", $this->userPermissions)){
			$return = array();
			$return['group_permissions'] = $this->laraStockPermissions;
			$return['roles'] = $this->getRoles();

			foreach ($return['roles'] as $role) {
				$return['role_permissions'][$role['id']] = array();
			}
			$this->output = $return;
		}else{$this->errors[] = __('You do not have permission to access this page', 'lara-google-analytics');}
		$this->jsonOutput();
	}	

	private function jsonOutput(){
		header('Content-Type: application/json; charset=utf-8');
		if (empty($this->errors)){
			$this->output['status'] = "done";
			echo json_encode($this->output, true);
		}else{ 
			if(in_array("administrator", $this->userRoles)){Common\ErrorHandler::setDebugMode(true);}
			Common\ErrorHandler::FatalError(__('Fatal Error', 'lara-google-analytics'),__('Could not get or set widget permissions .. please contact an administrator', 'lara-google-analytics'),10001,$this->errors); 
		}
		exit();
	}	

}

?>