<?php

/*
Plugin Name: Lara's Google Analytics
Plugin URI: https://www.xtraorbit.com/wordpress-google-analytics-dashboard-widget/
Description: Full width Google Analytics dashboard widget for Wordpress admin interface, which also inserts latest Google Analytics tracking code to your pages.
Version: 3.2.2
Author: Amr M. Ibrahim
Author URI: https://www.xtraorbit.com/
License: GPL2
Text Domain: lara-google-analytics
Domain Path: /languages/
*/

if (!defined("ABSPATH"))
    die("This file cannot be accessed directly");

define ("lrgawidget_plugin_version", "3.2.2");
define ("lrgawidget_plugin_scripts_version", "322");
define ("lrgawidget_plugin_prefiex", "lrgalite-");
define ("lrgawidget_plugin_dist_dir", plugin_dir_url( __FILE__ ).'dist/');
define ("lrgawidget_plugin_plugins_dir", plugin_dir_url( __FILE__ ).'dist/plugins/');

global $wpdb;
define ("lrgawidget_plugin_table", $wpdb->base_prefix . 'lrgawidget_global_settings');

register_activation_hook(__FILE__,'lrgawidget_activate');
register_uninstall_hook(__FILE__, 'lrgawidget_uninstall' );
add_action( 'admin_enqueue_scripts', 'lrgawidget_enqueue',1000 );
add_action( 'wp_ajax_lrgawidget_hideShowWidget', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getAuthURL', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getAccessToken', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getProfiles', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_setProfileID', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_settingsReset', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getSessions', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getBrowsers', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getLanguages', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getOS', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getDevices', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getScreenResolution', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getPages', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getGraphData', 'lrgawidget_callback' );
add_action( 'wp_ajax_lrgawidget_getPermissions', 'lrgawidget_permissions_editor' );
add_action( 'wp_head', 'lrgawidget_ga_code');

add_action( 'wp_ajax_lrgawidget_review_response', 'lrgawidget_review_response');

add_action( 'init', 'lrgawidget_load_textdomain' );
function lrgawidget_load_textdomain() {
  load_plugin_textdomain( 'lara-google-analytics', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' ); 
}

require_once(dirname(__FILE__).'/core/wp.helper.functions.php');

function lrgawidget_enqueue($hook) {
	if ( ('index.php' === $hook) && !is_network_admin() ){
		if (current_user_can('manage_options')) {
			$wstate = Lara\Utils\Common\WPHelperFunctions::get_current_user_option('lrgawidget_hideShowWidget');	
			if ($wstate !== "hide"){
				wp_enqueue_style( lrgawidget_plugin_prefiex.'lrgawidget', plugin_dir_url( __FILE__ ).'dist/css/'.lrgawidget_plugin_prefiex.'main.css'  ,array(),lrgawidget_plugin_scripts_version);
				wp_enqueue_script( 'jquery' );
				wp_enqueue_script( lrgawidget_plugin_prefiex.'main', plugin_dir_url( __FILE__ ).'dist/js/'.lrgawidget_plugin_prefiex.'main.js' ,array('jquery'),lrgawidget_plugin_scripts_version,true);
				wp_localize_script( lrgawidget_plugin_prefiex.'main', 'lrgawidget_ajax_object', array( 'lrgawidget_ajax_url' => admin_url( 'admin-ajax.php' ) ));	
				add_action('in_admin_header','lrga_welcome_panel');
			}else{
				wp_enqueue_script( 'jquery' );
				wp_enqueue_script( lrgawidget_plugin_prefiex.'main', plugin_dir_url( __FILE__ ).'dist/js/lrgawidget_control.js' ,array('jquery'),lrgawidget_plugin_scripts_version);
				wp_localize_script( lrgawidget_plugin_prefiex.'main', 'lrgawidget_ajax_object', array( 'lrgawidget_ajax_url' => admin_url( 'admin-ajax.php' ) ));
			}
			
			$already_rated = get_network_option(1,lrgawidget_plugin_prefiex.'already_rated', 'no');
			if ($already_rated == 'no'){
				require_once(dirname(__FILE__).'/core/wp.review.notice.php');
				Lara\Utils\Common\WPReviewNotice::show_review_notice();
			}
			
		}else{return;}
	}else{return;}
}

function lrgawidget_review_response() {
	require_once(dirname(__FILE__).'/core/wp.review.notice.php');
	Lara\Utils\Common\WPReviewNotice::review_response();
}

function lrgawidget_internal_permissions(){
	$parray = array();
	$globalWidgetPermissions = array("lrgawidget_perm_admin",
									 "lrgawidget_perm_perm",	
									 "lrgawidget_perm_sessions",
									 "lrgawidget_perm_browsers",
									 "lrgawidget_perm_languages",
									 "lrgawidget_perm_os",
									 "lrgawidget_perm_devices",
									 "lrgawidget_perm_screenres",
									 "lrgawidget_perm_pages",
									 "lrgawidget_perm_graph_options",
									 "lrgawidget_perm_ecom_woo",
									 "lrgawidget_perm_promo");	 
	$parray["permissions"] = $globalWidgetPermissions;
	return $parray;
}


function lrgawidget_permissions_editor() {
	require (dirname(__FILE__).'/core/lrgawidget.permissions.php');
	$call = new Lara\Utils\Common\permissions();

	if ($_POST['action'] == "lrgawidget_getPermissions"){
		$call->getCurrentBlogRolesPermissions();
	}
	
}

function lrgawidget_callback() {
	$lrperm = lrgawidget_internal_permissions();
	if (current_user_can('manage_options')) {
		array_walk_recursive($_POST, "Lara\Utils\Common\WPHelperFunctions::sanitizer");
		$lrdata = $_POST;
		$modifiedAction = explode("_", $lrdata['action']);
		$lrdata['action'] = sanitize_text_field($modifiedAction[1]);

		if ($lrdata['action'] == "hideShowWidget"){
			if ($lrdata['wstate'] === "show" || $lrdata['wstate'] === "hide"){
				Lara\Utils\Common\WPHelperFunctions::update_current_user_option('lrgawidget_hideShowWidget', $lrdata['wstate']);
				lrgawidget_jsonOutput();
			}
		}

		require (dirname(__FILE__).'/core/lrgawidget.handler.php');
	}
}

function lrgawidget_jsonOutput(){
	header('Content-Type: application/json; charset=utf-8');
	$output['status'] = "done";
	echo json_encode($output);	
	exit();
}

function lrga_welcome_panel() {
	$actLrgaTabs= array(); 
	$lrperm = lrgawidget_internal_permissions();
	$globalWidgetPermissions = $lrperm['permissions']; 
	require_once (dirname(__FILE__).'/widgets/lrgawidget.php');
}
 
function lrgawidget_ga_code(){
	Lara\Utils\Common\WPHelperFunctions::get_ga_code();
}  

function lrgawidget_activate() {
  	global $wpdb;
	if ( version_compare( PHP_VERSION, '5.6', '<' ) ) {
		deactivate_plugins( basename( __FILE__ ) );
		wp_die('<p>'.sprintf('This plugin can not be activated because it requires a PHP version greater than <b>5.6.0</b>.<br>You are currently using PHP <b>%1$s</b>.<br><br>Your PHP version can be updated by your hosting company.',PHP_VERSION).'</p><a href="'. admin_url('plugins.php').'">Go back</a>');
	}else{
		$wpdb->query("CREATE TABLE IF NOT EXISTS `".lrgawidget_plugin_table."` (`id` int(10) NOT NULL AUTO_INCREMENT, `name` TEXT NOT NULL, `value` TEXT NOT NULL, PRIMARY KEY (`id`))");
	}
}

function lrgawidget_uninstall() {
   	global $wpdb;
	$wpdb->query("DROP TABLE `".lrgawidget_plugin_table."`");
	delete_option('lrgawidget_property_id');
	delete_network_option( 1, lrgawidget_plugin_prefiex.'version' );
	delete_network_option( 1, lrgawidget_plugin_prefiex.'install_date' );
	delete_network_option( 1, lrgawidget_plugin_prefiex.'already_rated' );
}
?>